#include <SDL.h>
#include <stdlib.h>
#include <math.h>

#include "def.h"
#include "log.h"
#include "log.h"
#include "physics.h"
#include "opengl.h"
#include "ship.h"
#include "pilot.h"

static int quit = 0;

// Prototypes.
static void handle_keydown(SDLKey key);
static void handle_keyup(SDLKey key);

// Update.
static void update_all(void);

int main(int argc, const char** argv) {
  SDL_Event event;

  // Default window params.
  gl_screen.w = 800;
  gl_screen.h = 640;
  gl_screen.fullscreen = 0;
  if(gl_init()) {
    // Initializes video output.
    WARN("Error initializing video output, exiting...");
    exit(EXIT_FAILURE);
  }

  // Data loading.
  ships_load();

  // Main looops.
  while(!quit) {
    // Event loop.
    while(SDL_PollEvent(&event)) {
      switch(event.type) {
        case SDL_KEYDOWN:
          handle_keydown(event.key.keysym.sym);
          break;
        case SDL_KEYUP:
          handle_keyup(event.key.keysym.sym);
          break;
        case SDL_QUIT:
          quit = 1;
          break;
      }
    }
    update_all();
  }
  // Unload data.
  ships_free();
  gl_exit(); // Kills video output.
  exit(EXIT_SUCCESS);
}

// Handle keydown events.
static void handle_keydown(SDLKey key) {
  switch(key) {
    case SDLK_ESCAPE:
      quit = 1;
      break;
    default:
      break;
  }
}

// Handle keyup events.
static void handle_keyup(SDLKey key) {
  switch(key) {
    default:
      break;
  }
}

// Update all the things.
static void update_all(void) {
  glClear(GL_COLOR_BUFFER_BIT);
  SDL_GL_SwapBuffers();
}

